;------------------------------------
; aCONNECT Script (c) by Eistee v2.0
;------------------------------------

;-----------------
; aCONNECT - MENU
;-----------------
menu menubar,status {
  aCONNECT
  .Setup:aCONNECT
  .$submenu($aCONNECT.menu($1))
}
alias -l aCONNECT.menu {
  if ($1 == begin) return -
  if ($1 isnum) return $readini($+($scriptdir,aCONNECT.ini),Main,$+(n,$calc($1 - 1))) $+ :aCONNECT $readini($+($scriptdir,aCONNECT.ini),Main,$+(n,$calc($1 - 1)))
}

;-------------------
; aCONNECT - EVENTS
;-------------------
on *:START: {
  var %i = 0, %servers
  while ($readini($+($scriptdir,aCONNECT.ini),Main,$+(n,%i))) {
    if ($readini($+($scriptdir,aCONNECT.ini),$ifmatch,aCONNECT) == on) {
      var %servers = %servers $readini($+($scriptdir,aCONNECT.ini),Main,$+(n,%i))
    }
    inc %i
  }
  aCONNECT %servers
}
on *:DISCONNECT: {
  if (%aCONNECT [ $+ [ $cid ] ]) {
    var %Server = $readini($+($scriptdir,aCONNECT.ini),n,%aCONNECT [ $+ [ $cid ] ],Server)
    var %Fullname = $readini($+($scriptdir,aCONNECT.ini),n,%aCONNECT [ $+ [ $cid ] ],Fullname)
    var %Email = $readini($+($scriptdir,aCONNECT.ini),n,%aCONNECT [ $+ [ $cid ] ],Email)
    var %Nick = $readini($+($scriptdir,aCONNECT.ini),n,%aCONNECT [ $+ [ $cid ] ],Nick)
    var %Alternative = $readini($+($scriptdir,aCONNECT.ini),n,%aCONNECT [ $+ [ $cid ] ],Alternative)
    var %Firewall = $readini($+($scriptdir,aCONNECT.ini),n,%aCONNECT [ $+ [ $cid ] ],Firewall)
    var %Firewall-Type = $readini($+($scriptdir,aCONNECT.ini),n,%aCONNECT [ $+ [ $cid ] ],Firewall-Type)
    var %Firewall-Host = $readini($+($scriptdir,aCONNECT.ini),n,%aCONNECT [ $+ [ $cid ] ],Firewall-Host)
    var %Firewall-Port = $readini($+($scriptdir,aCONNECT.ini),n,%aCONNECT [ $+ [ $cid ] ],Firewall-Port)
    var %Firewall-User = $readini($+($scriptdir,aCONNECT.ini),n,%aCONNECT [ $+ [ $cid ] ],Firewall-User)
    var %Firewall-Pass = $readini($+($scriptdir,aCONNECT.ini),n,%aCONNECT [ $+ [ $cid ] ],Firewall-Pass)
    if (%Server && %Firewall && %Nick && %Alternative && %Email && %Fullname) {
      if (%Firewall == on) .firewall -m $+ %Firewall-Type on %Firewall-Host %Firewall-Port %Firewall-User %Firewall-Pass
      else .firewall off
      server %Server -i %Nick %Alternative %Email %Fullname
    }
  }
}
on *:CONNECT: {
  if (%aCONNECT [ $+ [ $cid ] ]) {
    var %i = 1
    while ($readini($+($scriptdir,aCONNECT.ini),n,%aCONNECT [ $+ [ $cid ] ],Perform-BeforeJoin $+ %i)) {
      var %performb = $iif(%performb,%performb $chr(124)) $readini($+($scriptdir,aCONNECT.ini),n,%aCONNECT [ $+ [ $cid ] ],Perform-BeforeJoin $+ %i)
      inc %i
    }
    if (%performb) {
      alias Perform-BeforeJoin { %performb }
      Perform-BeforeJoin
      alias Perform-BeforeJoin
    }
    $iif($readini($+($scriptdir,aCONNECT.ini),%aCONNECT [ $+ [ $cid ] ],Channels),join $ifmatch)
    var %i = 1
    while ($readini($+($scriptdir,aCONNECT.ini),%aCONNECT [ $+ [ $cid ] ],Perform-AfterJoin $+ %i)) {
      var %performa = $iif(%performa,%performa $chr(124)) $readini($+($scriptdir,aCONNECT.ini),n,%aCONNECT [ $+ [ $cid ] ],Perform-AfterJoin $+ %i)
      inc %i
    }
    if (%performa) {
      alias Perform-AfterJoin { %performa }
      Perform-AfterJoin
      alias Perform-AfterJoin
    }
  }
}
on ^*:CLOSE:*: if (($target == Status Window) && (%aCONNECT [ $+ [ $cid ] ])) unset %aCONNECT [ $+ [ $cid ] ]
on *:EXIT: unset %aCONNECT*

;-----------------------
; aCONNECT - MAIN ALIAS
;-----------------------
alias aCONNECT {
  if (!$1) dialog -m aCONNECT aCONNECT
  else {
    var %i = 1
    while (%i <= $0) {
      var %Server = $readini($+($scriptdir,aCONNECT.ini),$gettok($1-,%i,32),Server)
      var %Fullname = $readini($+($scriptdir,aCONNECT.ini),$gettok($1-,%i,32),Fullname)
      var %Email = $readini($+($scriptdir,aCONNECT.ini),$gettok($1-,%i,32),Email)
      var %Nick = $readini($+($scriptdir,aCONNECT.ini),$gettok($1-,%i,32),Nick)
      var %Alternative = $readini($+($scriptdir,aCONNECT.ini),$gettok($1-,%i,32),Alternative)
      var %Firewall = $readini($+($scriptdir,aCONNECT.ini),$gettok($1-,%i,32),Firewall)
      var %Firewall-Type = $readini($+($scriptdir,aCONNECT.ini),$gettok($1-,%i,32),Firewall-Type)
      var %Firewall-Host = $readini($+($scriptdir,aCONNECT.ini),$gettok($1-,%i,32),Firewall-Host)
      var %Firewall-Port = $readini($+($scriptdir,aCONNECT.ini),$gettok($1-,%i,32),Firewall-Port)
      var %Firewall-User = $readini($+($scriptdir,aCONNECT.ini),$gettok($1-,%i,32),Firewall-User)
      var %Firewall-Pass = $readini($+($scriptdir,aCONNECT.ini),$gettok($1-,%i,32),Firewall-Pass)
      if (%Server && %Firewall && %Nick && %Alternative && %Email && %Fullname) {
        if (%Firewall == on) .firewall -m $+ %Firewall-Type on %Firewall-Host %Firewall-Port %Firewall-User %Firewall-Pass
        else .firewall off
        var %newWindow = $iif($status != disconnected,-m,$null)
        server %newWindow %Server -i %Nick %Alternative %Email %Fullname
        set %aCONNECT [ $+ [ $iif(%newWindow,$scon($scon(0)).cid,$cid) ] ] $gettok($1-,%i,32)
      }
      inc %i
    }
    return
  }
}

;--------------------
; aCONNECT - DIALOGS
;--------------------
dialog -l aCONNECT {
  title "aCONNECT v2.0 by Eistee"
  size -1 -1 165 165
  option dbu
  text "Preset:", 1, 8 9 18 8
  combo 2, 27 8 68 133, size edit vsbar drop
  button "Add", 3, 96 8 20 10, disable
  button "Delete", 4, 117 8 20 10, disable
  button "Order", 5, 138 8 20 10
  tab "Settings", 6, 8 20 148 119
  box "", 7, 16 37 135 98, tab 6
  text "IRC Network:", 8, 21 46 38 8, tab 6 right
  combo 9, 60 45 86 96, tab 6 size vsbar drop
  text "IRC Server:", 10, 21 59 38 8, tab 6 right
  combo 11, 60 58 86 83, tab 6 size vsbar drop
  text "Full Name:", 12, 21 74 38 8, tab 6 right
  edit $fullname, 13, 60 73 86 10, tab 6
  text "Email Address:", 14, 21 85 38 8, tab 6 right
  edit $email, 15, 60 84 86 10, tab 6
  text "Nickname:", 16, 21 99 38 8, tab 6 right
  edit $mnick, 17, 60 98 60 10, tab 6
  text "Alternative:", 18, 21 110 38 8, tab 6 right
  edit $anick, 19, 60 109 60 10, tab 6
  check "Auto Connect on mIRC start", 20, 21 122 80 10, tab 6
  tab "Channels", 21
  box "", 22, 16 37 135 98, tab 21
  list 23, 21 45 116 74, tab 21 size vsbar
  button "^", 24, 137 46 8 35, disable tab 21 flat
  button "v", 25, 137 82 8 35, disable tab 21 flat
  button "Add", 26, 21 119 41 10, tab 21
  button "Edit", 27, 103 119 42 10, disable tab 21
  button "Delete", 28, 62 119 41 10, disable tab 21
  tab "Perform", 29
  box "Before Join", 30, 16 37 135 47, tab 29
  edit "", 31, 21 45 125 34, tab 29 multi return autohs autovs hsbar vsbar
  box "After Join", 32, 16 88 135 47, tab 29
  edit "", 33, 21 96 125 34, tab 29 multi return autohs autovs hsbar vsbar
  tab "Firewall", 34
  check "Firewall support:", 35, 16 38 49 10, tab 34
  box "", 36, 16 50 135 85, tab 34
  text "Protocol:", 37, 21 62 38 8, tab 34 right disable
  combo 38, 60 61 50 50, tab 34 size drop disable
  text "Hostname:", 39, 21 79 38 8, tab 34 right disable
  edit "", 40, 60 78 50 10, tab 34 disable
  text "Port:", 41, 21 91 38 8, tab 34 right disable
  edit "", 42, 60 90 30 10, tab 34 disable
  text "User ID:", 43, 21 106 38 8, tab 34 right disable
  edit "", 44, 60 105 40 10, tab 34 disable
  text "Password:", 45, 21 118 38 8, tab 34 right disable
  edit "", 46, 60 118 40 10, tab 34 disable
  link "aCONNECT v2.0", 47, 9 149 50 8
  button "OK", 48, 79 147 37 12, ok
  button "Cancel", 49, 120 147 37 12, cancel
  list 50, 0 0 0 0, hide
}
dialog -l Order {
  title "Order"
  size -1 -1 106 92
  option dbu
  list 1, 8 8 81 62, size vsbar
  button "^", 2, 90 9 8 30, disable flat
  button "v", 3, 90 39 8 30, disable flat
  button "OK", 4, 9 74 89 10, ok
}
dialog -l Chan {
  title "Add Channel"
  size -1 -1 105 52
  option dbu
  text "Channel:", 1, 8 9 29 8
  edit "", 2, 37 8 60 10
  text "Password:", 3, 8 22 29 8
  edit "", 4, 37 21 60 10
  button "OK", 5, 8 34 88 10, ok
}
on *:DIALOG:aCONNECT:init:0: {
  var %server = 1, %name = 0, %network
  while ($readini($+($scriptdir,aCONNECT.ini),n,Main,$+(n,%name))) {
    did -a aCONNECT 2 $ifmatch
    inc %name
  }
  did -a aCONNECT 9 All
  while (%server <= $server(0)) {
    did -a aCONNECT 11 $server(%server).desc
    did -a aCONNECT 50 $server(%server) $server(%server).port
    if (!$didwm(9,$server(%server).group)) {
      did -a aCONNECT 9 $server(%server).group
    }
    inc %server
  }
  did -c aCONNECT 9,11 1
  did -a aCONNECT 38 Socks4
  did -a aCONNECT 38 Socks5
  did -a aCONNECT 38 Proxy
}
on *:DIALOG:aCONNECT:edit:2: if ($len($did(2)) <= 1) aCONNECT:new.init
alias -l aCONNECT:new.init {
  did -a aCONNECT 3 Add
  did $iif($did(2),-e,-b) aCONNECT 3
  did -b aCONNECT 4,24,25,27,28,37,38,39,40,41,42,43,44,45,46
  did -u aCONNECT 20,35,38
  did -r aCONNECT 13,15,17,19,23,31,33,40,42,44,46
  if ($did(9).seltext != All) {
    did -r aCONNECT 11,50
    var %server = 1
    while (%server <= $server(0)) {
      did -a aCONNECT 11 $server(%server).desc
      did -a aCONNECT 50 $server(%server) $server(%server).port
      inc %server
    }
  }
  did -c aCONNECT 9,11,50 1
  did -a aCONNECT 13 $fullname
  did -a aCONNECT 15 $email
  did -a aCONNECT 17 $mnick
  did -a aCONNECT 19 $anick
}
on *:DIALOG:aCONNECT:sclick:2: aCONNECT:load
alias -l aCONNECT:load {
  did -a aCONNECT 3 Save
  did -e aCONNECT 3,4
  var %i = 1, %performb, %performa
  did -r aCONNECT 11,13,15,17,19,23,31,33,40,42,44,46,50
  did -c aCONNECT 9 $didwm(9,$readini($+($scriptdir,aCONNECT.ini),n,$did(2),Network))
  while (%i <= $server(0)) {
    if (($readini($+($scriptdir,aCONNECT.ini),n,$did(2),Network) == $server(%i).group) || ($readini($+($scriptdir,aCONNECT.ini),n,$did(2),Network) == All)) {
      did -a aCONNECT 11 $server(%i).desc
      did -a aCONNECT 50 $server(%i) $server(%i).port
    }
    inc %i
  }
  did -c aCONNECT 11,50 $didwm(50,$readini($+($scriptdir,aCONNECT.ini),n,$did(2),Server))
  did -a aCONNECT 13 $readini($+($scriptdir,aCONNECT.ini),n,$did(2),Fullname)
  did -a aCONNECT 15 $readini($+($scriptdir,aCONNECT.ini),n,$did(2),Email)
  did -a aCONNECT 17 $readini($+($scriptdir,aCONNECT.ini),n,$did(2),Nick)
  did -a aCONNECT 19 $readini($+($scriptdir,aCONNECT.ini),n,$did(2),Alternative)
  did $iif($readini($+($scriptdir,aCONNECT.ini),n,$did(2),aCONNECT) == on,-c,-u) aCONNECT 20
  var %i = 1
  while ($gettok($gettok($readini($+($scriptdir,aCONNECT.ini),n,$did(2),Channels),1,32),%i,44)) {
    did -a aCONNECT 23 $gettok($gettok($readini($+($scriptdir,aCONNECT.ini),n,$did(2),Channels),1,32),%i,44) $iif($gettok($gettok($readini($+($scriptdir,aCONNECT.ini),$did(2),Channels),2,32),%i,44) != nokey,$ifmatch)
    inc %i
  }
  var %i = 1
  while ($readini($+($scriptdir,aCONNECT.ini),n,$did(2),Perform-BeforeJoin $+ %i)) {
    var %performb = $iif(%performb,%performb $+ $crlf) $+ $readini($+($scriptdir,aCONNECT.ini),n,$did(2),Perform-BeforeJoin $+ %i)
    inc %i
  }
  did -a aCONNECT 31 %performb
  var %i = 1
  while ($readini($+($scriptdir,aCONNECT.ini),n,$did(2),Perform-AfterJoin $+ %i)) {
    var %performa = $iif(%performa,%performa $+ $crlf) $+ $readini($+($scriptdir,aCONNECT.ini),n,$did(2),Perform-AfterJoin $+ %i)
    inc %i
  }
  did -a aCONNECT 33 %performa
  did $iif($readini($+($scriptdir,aCONNECT.ini),n,$did(2),Firewall) == on,-c,-u) aCONNECT 35
  did $iif($readini($+($scriptdir,aCONNECT.ini),n,$did(2),Firewall) == on,-e,-b) aCONNECT 37,38,39,40,41,42,43,44,45,46
  if ($readini($+($scriptdir,aCONNECT.ini),n,$did(2),Firewall) == on) {
    did -c aCONNECT 38 $replace($readini($+($scriptdir,aCONNECT.ini),n,$did(2),Firewall-Type),4,1,5,2,p,3)
    did -a aCONNECT 40 $readini($+($scriptdir,aCONNECT.ini),n,$did(2),Firewall-Host)
    did -a aCONNECT 42 $readini($+($scriptdir,aCONNECT.ini),n,$did(2),Firewall-Port)
    did -a aCONNECT 44 $readini($+($scriptdir,aCONNECT.ini),n,$did(2),Firewall-User)
    did -a aCONNECT 46 $readini($+($scriptdir,aCONNECT.ini),n,$did(2),Firewall-Pass)
  }
}
on *:DIALOG:aCONNECT:sclick:4: {
  var %name = 1, %i = 0
  remini $+(",$scriptdir,aCONNECT.ini,") $did(2).seltext
  while (%name <= $did(2).lines) {
    if ($did(2,%name) != $did(2).seltext) {
      writeini -n $+(",$scriptdir,aCONNECT.ini,") Main $+(n,%i) $did(2,%name)
      inc %i
    }
    inc %name
  }
  remini $+(",$scriptdir,aCONNECT.ini,") Main $+(n,%i)
  did -d aCONNECT 2 $did(2).sel
  did -d aCONNECT 2 0
  aCONNECT:new.init
}
on *:DIALOG:aCONNECT:sclick:5: $dialog(aCONNECT-Order,Order,-4)
on *:DIALOG:aCONNECT:sclick:9: {
  var %server = 1
  did -r aCONNECT 11,50
  while (%server <= $server(0)) {
    if (($did(9) == $server(%server).group) || ($did(9) == All)) {
      did -a aCONNECT 11 $server(%server).desc
      did -a aCONNECT 50 $server(%server) $server(%server).port
    }
    inc %server
  }
  did -c aCONNECT 11 1
}
on *:DIALOG:aCONNECT:dclick:23: $dialog(aCONNECT-EditChan,Chan,-4)
on *:DIALOG:aCONNECT:sclick:23: {
  did $iif($did(23).sel > 1,-e,-b) aCONNECT 24
  did $iif($did(23).sel < $did(23).lines,-e,-b) aCONNECT 25
  did $iif($did(23).sel,-e,-b) aCONNECT 27,28
}
on *:DIALOG:aCONNECT:sclick:24: {
  var %seltxt = $did(23).seltext, %selid =  $did(23).sel, %uptxt = $did(23,$calc($did(23).sel - 1)), %upid = $calc($did(23).sel - 1)
  did -o aCONNECT 23 %upid %seltxt
  did -o aCONNECT 23 %selid %uptxt
  did -c aCONNECT 23 %upid
  did $iif($did(23).sel > 1,-e,-b) aCONNECT 24
  did $iif($did(23).sel < $did(23).lines,-e,-b) aCONNECT 25
}
on *:DIALOG:aCONNECT:sclick:25: {
  var %seltxt = $did(23).seltext, %selid =  $did(23).sel, %downtxt = $did(23,$calc($did(23).sel + 1)), %downid = $calc($did(23).sel + 1)
  did -o aCONNECT 23 %downid %seltxt
  did -o aCONNECT 23 %selid %downtxt
  did -c aCONNECT 23 %downid
  did $iif($did(23).sel > 1,-e,-b) aCONNECT 24
  did $iif($did(23).sel < $did(23).lines,-e,-b) aCONNECT 25
}
on *:DIALOG:aCONNECT:sclick:26: $dialog(aCONNECT-AddChan,Chan,-4)
on *:DIALOG:aCONNECT:sclick:27: $dialog(aCONNECT-EditChan,Chan,-4)
on *:DIALOG:aCONNECT:sclick:28: did -d aCONNECT 23 $did(23).sel | did -b aCONNECT 24,25
on *:DIALOG:aCONNECT:sclick:35: did $iif($did(35).state,-e,-b) aCONNECT 37,38,39,40,41,42,43,44,45,46
on *:DIALOG:aCONNECT:sclick:47: run http://www.mircscripts.org/comments.php?id=2055
on *:DIALOG:aCONNECT:sclick:3,48: {
  if ($did(2)) {
    var %i = 0, %channels, %passes
    if ($did(3) == Add) {
      :start
      if (Main == $did(2)) {
        if ($?="Please enter an another Name. $crlf $+ Not allowed is: Main") { did -o aCONNECT 2 0 $replace($ifmatch,$chr(32),$chr(160)) | goto start }
        else halt
      }
      did -o aCONNECT 2 0 $replace($did(2),$chr(32),$chr(160))
      while ($readini($+($scriptdir,aCONNECT.ini),n,Main,$+(n,%i))) inc %i
      writeini -n $+(",$scriptdir,aCONNECT.ini,") Main $+(n,%i) $did(2)
      did -a aCONNECT 2 $did(2)
      did -c aCONNECT 2 $calc(%i + 1)
      did -a aCONNECT 3 Save
      did -e aCONNECT 4
    }
    writeini -n $+(",$scriptdir,aCONNECT.ini,") $did(2) Network $did(9)
    writeini -n $+(",$scriptdir,aCONNECT.ini,") $did(2) Server $did(50,$did(11).sel)
    writeini -n $+(",$scriptdir,aCONNECT.ini,") $did(2) Fullname $did(13)
    writeini -n $+(",$scriptdir,aCONNECT.ini,") $did(2) Email $did(15)
    writeini -n $+(",$scriptdir,aCONNECT.ini,") $did(2) Nick $did(17)
    writeini -n $+(",$scriptdir,aCONNECT.ini,") $did(2) Alternative $did(19)
    writeini -n $+(",$scriptdir,aCONNECT.ini,") $did(2) aCONNECT $iif($did(20).state,on,off)
    var %chan = 1
    while (%chan <= $did(23).lines) {
      var %channels = $iif(%channels != $null,$+(%channels,$chr(44))) $+ $gettok($did(23,%chan),1,32)
      var %passes = $iif(%passes != $null,$+(%passes,$chr(44))) $+ $iif($gettok($did(23,%chan),2,32),$ifmatch,nokey)
      inc %chan
    }
    if (%channels) writeini -n $+(",$scriptdir,aCONNECT.ini,") $did(2) Channels %channels %passes
    else remini $+(",$scriptdir,aCONNECT.ini,") $did(2) Channels
    var %i = 1, %j = 1
    while (%i <= $did(31).lines) {
      if ($did(31,%i)) {
        writeini -n $+(",$scriptdir,aCONNECT.ini,") $did(2) Perform-BeforeJoin $+ %j $did(31,%i)
        inc %j
      }
      inc %i
    }
    while ($readini($+($scriptdir,aCONNECT.ini),$did(2),Perform-BeforeJoin $+ %j)) {
      remini $+(",$scriptdir,aCONNECT.ini,") $did(2) Perform-BeforeJoin $+ %j
      inc %j
    }
    var %i = 1, %j = 1
    while (%i <= $did(33).lines) {
      if ($did(33,%i)) {
        writeini -n $+(",$scriptdir,aCONNECT.ini,") $did(2) Perform-AfterJoin $+ %j $did(33,%i)
        inc %j
      }
      inc %i
    }
    while ($readini($+($scriptdir,aCONNECT.ini),$did(2),Perform-AfterJoin $+ %j)) {
      remini $+(",$scriptdir,aCONNECT.ini,") $did(2) Perform-AfterJoin $+ %j
      inc %j
    }
    writeini -n $+(",$scriptdir,aCONNECT.ini,") $did(2) Firewall $iif($did(35).state,on,off)
    if ($did(38)) writeini -n $+(",$scriptdir,aCONNECT.ini,") $did(2) Firewall-Type $replace($did(38),Socks4,4,Socks5,5,Proxy,p)
    if ($did(40)) writeini -n $+(",$scriptdir,aCONNECT.ini,") $did(2) Firewall-Host $did(40)
    if ($did(42)) writeini -n $+(",$scriptdir,aCONNECT.ini,") $did(2) Firewall-Port $did(42)
    if ($did(44)) writeini -n $+(",$scriptdir,aCONNECT.ini,") $did(2) Firewall-User $did(44)
    if ($did(46)) writeini -n $+(",$scriptdir,aCONNECT.ini,") $did(2) Firewall-Pass $did(46)
    if ($did == 3) aCONNECT:load
    flushini $+(",$scriptdir,aCONNECT.ini,")
  }
}
on *:DIALOG:aCONNECT-Order:init:0: {
  var %i = 0
  while ($readini($+($scriptdir,aCONNECT.ini),n,Main,$+(n,%i))) {
    did -a aCONNECT-Order 1 $ifmatch
    inc %i
  }
}
on *:DIALOG:aCONNECT-Order:sclick:1: did $iif($did(1).sel > 1,-e,-b) aCONNECT-Order 2 | did $iif($did(1).sel < $did(1).lines,-e,-b) aCONNECT-Order 3
on *:DIALOG:aCONNECT-Order:sclick:2: {
  var %seltxt = $did(1).seltext, %selid =  $did(1).sel, %uptxt = $did(1,$calc($did(1).sel - 1)), %upid = $calc($did(1).sel - 1)
  did -o aCONNECT-Order 1 %upid %seltxt | did -o aCONNECT-Order 1 %selid %uptxt | did -c aCONNECT-Order 1 %upid
  did $iif($did(1).sel > 1,-e,-b) aCONNECT-Order 2 | did $iif($did(1).sel < $did(1).lines,-e,-b) aCONNECT-Order 3
}
on *:DIALOG:aCONNECT-Order:sclick:3: {
  var %seltxt = $did(1).seltext, %selid =  $did(1).sel, %downtxt = $did(1,$calc($did(1).sel + 1)), %downid = $calc($did(1).sel + 1)
  did -o aCONNECT-Order 1 %downid %seltxt | did -o aCONNECT-Order 1 %selid %downtxt | did -c aCONNECT-Order 1 %downid
  did $iif($did(1).sel > 1,-e,-b) aCONNECT-Order 2 | did $iif($did(1).sel < $did(1).lines,-e,-b) aCONNECT-Order 3
}
on *:DIALOG:aCONNECT-Order:sclick:4: {
  var %i = 1
  did -r aCONNECT 2
  while (%i <= $did(1).lines) {
    writeini -n $+(",$scriptdir,aCONNECT.ini,") Main $+(n,$calc(%i - 1)) $did(1,%i)
    did -a aCONNECT 2 $did(1,%i)
    inc %i
  }
}
on *:DIALOG:aCONNECT-AddChan:sclick:5: if ($did(2)) did -a aCONNECT 23 $did(2) $did(4) | did $iif($did(aCONNECT,23).sel < $did(aCONNECT,23).lines,-e,-b) aCONNECT 25
on *:DIALOG:aCONNECT-EditChan:init:0: dialog -t aCONNECT-EditChan Edit Channel | did -a aCONNECT-EditChan 2 $gettok($did(aCONNECT,23).seltext,1,32) | did -a aCONNECT-EditChan 4 $gettok($did(aCONNECT,23).seltext,2,32)
on *:DIALOG:aCONNECT-EditChan:sclick:5: if ($did(2)) did -o aCONNECT 23 $did(aCONNECT,23).sel $did(2) $did(4)
